// LwButtonTest.java
import java.awt.*;
import java.awt.event.*;
class MyButton extends Component {
	Image i1, i2;
	transient ActionListener a;
	String acmd;
	boolean up = true;
	int w, h;
	MyButton(String acmd) {
		this.acmd = acmd;
		i1 = getToolkit().getImage("images/Bird3.gif");
		i2 = getToolkit().getImage("images/Bird1.gif");
		addMouseListener(new MyMouseAdapter());
		MediaTracker mt = new MediaTracker(this);
		try {
			mt.addImage(i1, 0); mt.addImage(i2, 1);
			mt.waitForAll();
		} catch(InterruptedException e) { }
		w = i1.getWidth(null); h = i2.getHeight(null);
	}
	class MyMouseAdapter extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			up = false; repaint();
		}
		public void mouseReleased(MouseEvent e) {
			up = true; repaint();
			ActionEvent ae = new ActionEvent(MyButton.this,
				ActionEvent.ACTION_PERFORMED, acmd);
			processEvent(ae);
		}
	}
	protected void processEvent(AWTEvent e) {
		if (e instanceof ActionEvent && a != null) {
			a.actionPerformed((ActionEvent)e);
			return;
		}
		super.processEvent(e);
	}
	public synchronized void addActionListener(ActionListener l) {
		a = AWTEventMulticaster.add(a, l);
	}
	public void removeActionListener(ActionListener l) {
		a = AWTEventMulticaster.remove(a, l);
	}
	public Dimension getPreferredSize(){return new Dimension(w,h);}
	public boolean contains(int x, int y) {return (x<w && y<h); }
	public void paint(Graphics g) {
		Image i = (up ? i1 : i2);
		g.drawImage(i, 0, 0, this);
	}
}
class LwButtonTest extends Frame {
	LwButtonTest() {
		setLayout(new FlowLayout());
		MyButton b = (MyButton) add(new MyButton("Hello"));
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println(e.getActionCommand());
			}
		});
		setSize(150,150);
		setVisible(true);
	}
	public static void main(String args[]) {
		new LwButtonTest();
	}
}
