// PathIteratorTest.java
import java.awt.geom.*;
class PathIteratorTest {
	public static void main(String[] args) {
		Rectangle2D r = new Rectangle2D.Double(0, 0, 100, 100);
		PathIterator pi = r.getPathIterator(null);
		while (!pi.isDone()) {
			printSegment(pi);
			pi.next();
		}
	}
	static void printSegment(PathIterator pi) {
		double[] d = new double[6];
		switch(pi.currentSegment(d)) {
			case PathIterator.SEG_MOVETO:
				System.out.println("move to " + 
					d[0] + ", " + d[1]);
				break;
			case PathIterator.SEG_LINETO:
				System.out.println("line to " + 
					d[0] + ", " + d[1]);
				break;
			case PathIterator.SEG_QUADTO:
				System.out.println("quadratic to " +
					d[0] + ", " + d[1] + ", " +
					d[2] + ", " + d[3]);
				break;
			case PathIterator.SEG_CUBICTO:
				System.out.println("cubic to " +
					d[0] + ", " + d[1] + ", " +
					d[2] + ", " + d[3] + ", " +
					d[4] + ", " + d[5]);
				break;
			case PathIterator.SEG_CLOSE:
				System.out.println("close");
			default:
		}
	}
}
